%bcond_without qt5

Summary:	Port to Qt of Neil Hodgson's Scintilla C++ editor class
Name:		qscintilla
Version:	2.8.4
Release:	7
License:	GPLv2+
Group:		System/Libraries
Url:		http://www.riverbankcomputing.co.uk/software/qscintilla/intro
Source0:	http://downloads.sf.net/pyqt/QScintilla-gpl-%{version}.tar.gz
Patch0:		QScintilla-gpl-2.2-libdir.patch
Patch1:		QScintilla-gpl-2.8.1-libs.patch
Patch2:		qsci_link.patch
Patch3:		QScintilla-gpl-2.8.4-qt5.patch
BuildRequires:	qt4-devel
BuildRequires:	python-sip
BuildRequires:	python-qt4-devel
BuildRequires:	pkgconfig(python)
%if %{with qt5}
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5Designer)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5PrintSupport)
BuildRequires:	pkgconfig(Qt5Widgets)
%endif

%description
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

#----------------------------------------------------------------------------

%package i18n
Summary:	Translations used by %{name}
Group:		System/Libraries
Conflicts:	libqscintilla2_9 < 2.8.3
Conflicts:	lib64qscintilla2_9 < 2.8.3
BuildArch:	noarch

%description i18n
Translations used by %{name}.

%files i18n
%{_qt_translationdir}/qscintilla*.qm

#----------------------------------------------------------------------------

%if %{with qt5}
%package qt5-i18n
Summary:	Translations used by %{name}-qt5
Group:		System/Libraries
BuildArch:	noarch

%description qt5-i18n
Translations used by %{name}-qt5.

%files qt5-i18n
%{_qt5_translationsdir}/qscintilla*.qm
%endif

#----------------------------------------------------------------------------

%define major 11
%define libqs4 %mklibname qscintilla2_ %{major}

%package -n %{libqs4}
Summary:	Port to Qt4 of Neil Hodgson's Scintilla C++ editor class
Group:		System/Libraries
Requires:	%{name}-i18n

%description -n %{libqs4}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs4}
%{qt4lib}/libqscintilla2.so.%{major}*

#----------------------------------------------------------------------------

%define libqs4dev %mklibname -d qscintilla

%package -n %{libqs4dev}
Summary:	Libraries, include to develop applications with QScintilla for Qt4
Group:		Development/KDE and Qt
Requires:	%{libqs4} = %{EVRD}
Provides:	%{name}-qt4-devel = %{EVRD}
Provides:	qscintilla-qt4-devel = %{EVRD}

%description -n %{libqs4dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs4dev}
%{qt4dir}/mkspecs/features/qscintilla2.prf
%{qt4dir}/include/*
%{qt4lib}/libqscintilla2.so
%{qt4plugins}/designer/libqscintillaplugin.so

#----------------------------------------------------------------------------

%define libqs5 %mklibname qt5scintilla2_ %{major}

%package -n %{libqs5}
Summary:	Port to Qt5 of Neil Hodgson's Scintilla C++ editor class
Group:		System/Libraries
Requires:	%{name}-qt5-i18n

%description -n %{libqs5}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs5}
%{_qt5_libdir}/libqt5scintilla2.so.%{major}*

#----------------------------------------------------------------------------

%define libqs5dev %mklibname -d qt5scintilla

%package -n %{libqs5dev}
Summary:	Libraries, include to develop applications with QScintilla for Qt5
Group:		Development/KDE and Qt
Requires:	%{libqs5} = %{EVRD}
Provides:	%{name}-qt5-devel = %{EVRD}
Provides:	qscintilla-qt5-devel = %{EVRD}

%description -n %{libqs5dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs5dev}
%{_qt5_datadir}/mkspecs/features/qscintilla2.prf
%{_qt5_includedir}/Qsci/*.h
%{_qt5_libdir}/libqt5scintilla2.so
%{_qt5_plugindir}/designer/libqscintillaplugin.so

#----------------------------------------------------------------------------

%package -n python-qt4-qscintilla
Summary:	Python qt4 QScintilla bindings
Group:		Development/KDE and Qt
Requires:	python-qt4-core
Requires:	python-qt4-gui
Requires:	%{libqs4} = %{EVRD}
Requires:	sip-api(%{sip_api_major}) = %{sip_api}

%description -n python-qt4-qscintilla
Python qt4 QScintilla bindings.

%files -n python-qt4-qscintilla
%{_datadir}/sip/PyQt4
%{qt4dir}/qsci
%{py_platsitedir}/PyQt4/Qsci.so

#----------------------------------------------------------------------------

%package doc
Summary:	QScintilla documentation
Group:		Documentation
BuildArch:	noarch

%description doc
QScintilla documentation.

%files doc
%doc NEWS README doc

#----------------------------------------------------------------------------

%prep
%setup -qn QScintilla-gpl-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%if %{with qt5}
cp -r Qt4Qt5 Qt5
cp -r designer-Qt4Qt5 designer-Qt5
%patch3 -p1
%endif

%build
pushd Qt4Qt5
    export QTDIR=%{qt4dir}/qsci
    %qmake_qt4 DESTDIR=%{buildroot}%{qt4lib} qscintilla.pro
    %make
popd

pushd designer-Qt4Qt5
    echo "INCLUDEPATH += ../Qt4Qt5" >> designer.pro
    echo "LIBS += -L%{buildroot}%{qt4lib}" >> designer.pro
    %qmake_qt4 designer.pro
    make
popd

%if %{with qt5}
pushd Qt5
    export QTDIR=%{_qt5_libdir}/qsci
    %qmake_qt5 DESTDIR=%{buildroot}%{_qt5_libdir} qscintilla.pro
    %make
popd

pushd designer-Qt5
    echo "INCLUDEPATH += ../Qt5" >> designer.pro
    echo "LIBS += -L%{buildroot}%{_qt5_libdir}" >> designer.pro
    %qmake_qt5 designer.pro
    make
popd
%endif

%install
mkdir -p %{buildroot}%{qt4lib}

pushd Qt4Qt5
    make INSTALL_ROOT=%{buildroot} install
popd

pushd designer-Qt4Qt5
    make INSTALL_ROOT=%{buildroot} install
popd

%if %{with qt5}
pushd Qt5
    make INSTALL_ROOT=%{buildroot} install
popd

pushd designer-Qt5
    make INSTALL_ROOT=%{buildroot} install
popd

# Don't build Python bindings for Qt5 yet
rm -rf %{buildroot}%{_qt5_datadir}/qsci/api/python
%endif

pushd Python
    export QTDIR=%{_qt4_datadir}
    export PATH=%{_qt4_datadir}/bin:$PATH
    python configure.py \
        -n ../Qt4Qt5 \
        -o %{buildroot}%{qt4lib}
    %make
    make install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
popd

%changelog

* Thu Sep 07 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 2.8.4-7
- (d64cac8) Bump release


